import globalHandler
glb = globalHandler.start()

import playerHandler
pH = playerHandler.start()

import toolsHandler
tH = toolsHandler.start()

import host
import bf2
import math
import random

class commandHandler:
	def __init__(self):
		host.registerGameStatusHandler(self.onGameStatusChanged)
		host.registerHandler('RemoteCommand', self.onRemoteCommand, 1)
		host.registerHandler('ChatMessage', self.onChatMessage, 1)
		self.infiniteTimer = None
		self.disabled = False
		self.masterAdmins = ['Freeze-18','AwesomeATrain','Medic8402'] # Can toggle commandHandler
		self.admins = ['JuniorV8','ARROWHEAD5647','ChaosSorcerer','Eliminator13','Skillet2','Jagged-Fel','UnordinaryPunk','snipermaster45','M.E.G.A.S','wassupNL','TundaStrike','MylesMan9','bondservent','choppergirl','DooDooDooDoo','ImGannaDie','Owen5780','Samula5647']
		self.spawnList = []

	def onGameStatusChanged(self, status):
		self.spawnList = []

	def onChatMessage(self, playerId, text, channel, flags): # add *WHISPER* to textdeletions
		glb.playerMessages.append(self.name(playerId, 0) + ": " + text)
		textDeletions = ['HUD_TEXT_CHAT_TEAM','HUD_TEXT_CHAT_SQUAD','HUD_CHAT_DEADPREFIX','HUD_CHAT_SPECTATORPREFIX','*\xA71DEAD\xA70*','HUD_TEXT_CHAT_COMMANDER']
		textAccidents = ['j#','k#','l#']
		sentText = self.textClip(text, textDeletions)
		cmd = sentText
		if cmd[0:2] in textAccidents: cmd = cmd[1:]
		if cmd[0:1] == "#": self.onRemoteCommand(playerId, cmd[1:])

	def onRemoteCommand(self, playerId, command):
		if playerId == -1: playerId = 255
		c = command.split(" ")[0].lower()
		p = command[len(c) + 1:]
		pParts = p.split(" ")
		if not self.disabled:
			self.playerCommands(c, p, pParts, bf2.PlayerManager.Player(playerId))
			if self.admin(self.name(playerId, 1)): self.adminCommands(c, p, pParts, bf2.PlayerManager.Player(playerId))
			if self.masterAdmin(self.name(playerId, 1)): self.masterAdminCommands(c, p, pParts, bf2.PlayerManager.Player(playerId))
		elif self.disabled and self.masterAdmin(self.name(playerId, 1)):
			self.playerCommands(c, p, pParts, bf2.PlayerManager.Player(playerId))
			self.masterAdminCommands(c, p, pParts, bf2.PlayerManager.Player(playerId))

	def playerCommands(self, c, p, pParts, player):
		tParts = len(pParts)
		if c == "info":
			self.sM("Running Freeze's 2142 Python Server Handler", True)
			self.sM("Much inspiration and guidelines from Elxx's Sandbox Core", True)
		elif c == "help":
			self.sM("Commands are: #ju, #flip, and #rotate", True)
		elif c == "ju":
			vehicle = bf2.objectManager.getRootParent(player.getVehicle())
			if vehicle.isTitan():
				self.sM("You can't move a titan.", False)
			else:
				pos = vehicle.getPosition()
				pos = pos[0],pos[1] + float(pParts[0]),pos[2]
				if pos[1] > 5000:
					self.sM("Your height cannot exceed 5000.", False)
				else:
					vehicle.setPosition(pos)
		elif c == "flip":
			vehicle = bf2.objectManager.getRootParent(player.getVehicle())
			if vehicle.isTitan():
				self.sM("You can't flip a titan.", False)
			else:
				rot = vehicle.getRotation()
				rot = rot[0],rot[1] + 180,rot[2]
				vehicle.setRotation(rot)
		if p:
			if c == "rotate":
				vehicle = bf2.objectManager.getRootParent(player.getVehicle())
				if vehicle.isTitan():
					self.sM("You can't rotate a titan.", False)
				else:
					rot = vehicle.getRotation()
					rot = rot[0] + int(pParts[0]),rot[1] + int(pParts[1]),rot[2] + int(pParts[2])
					vehicle.setRotation(rot)

	def adminCommands(self, c, p, pParts, player):
		tParts = len(pParts)
		if c == "relocateallhere":
			relocations = 0
			origPos = player.getVehicle().getPosition()
			for x in bf2.playerManager.getPlayers():
				vehicle = bf2.objectManager.getRootParent(x.getVehicle())
				if not vehicle.isTitan() and x.index != self.getPlayerId(player):
					angle = 360*relocations
					newPos = ((10*math.cos(angle)) + origPos[0],origPos[1] + 1,(10*math.sin(angle)) + origPos[2])
					vehicle.setPosition(newPos)
					relocations += 1
		elif c == "root":
			vehicle = bf2.objectManager.getRootParent(player.getVehicle())
			self.sM(vehicle.templateName, True)
		elif c == "listchildren":
			children = bf2.objectManager.getRootParent(player.getVehicle()).getChildren()
			for x in children:
				self.sM(x.templateName, True)
		elif c == "decoys":
			team = 1
			if player.getTeam() == 1: team = 2
			tH.podDecoys(team)
		if p:
			if c == "c":
				self.rI(p)
			elif c == "spawnspeed":
				self.rI("gameLogic.spawnObjectSpeed " + pParts[0])
			elif c == "fakeknife":
				if tParts > 1:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = [pParts[1]]
				bf2.gameLogic.sendHudEvent(player, 40, int(pParts[0]))
			elif c == "hudevent":
				if tParts > 2:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = [pParts[1],pParts[2]]
				bf2.gameLogic.sendHudEvent(player, int(pParts[0]), int(pParts[1]))
			elif c == "settickets":
				bf2.gameLogic.setTickets(player.getTeam(), int(pParts[0]))
				team = 1
				if player.getTeam() == 1: team = 2
				bf2.gameLogic.setTickets(team, int(pParts[1]))
			elif c == "deadtime":
				if tParts > 1:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = [pParts[1]]
				player.setTimeToSpawn(int(pParts[0]))
			elif c == "test":
				objs = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.ControlPoint')
				#objs = bf2.objectManager.getObjectsOfTemplate(pParts[0])
				for x in objs:
					x.setPosition(player.getVehicle().getPosition())
			elif c == "test2":
				objs = bf2.objectManager.getObjectsOfType(p)
				for x in objs:
					self.sM(str(x), True)
			elif c == "test3":
				relocations = 0
				origPos = player.getVehicle().getPosition()
				vehicles = bf2.objectManager.getObjectsOfTemplate(pParts[0])
				for x in vehicles:
					if not x.isTitan():
						vehicle = x
						angle = 360*relocations
						newPos = ((10*math.cos(angle)) + origPos[0],origPos[1] + relocations,(10*math.sin(angle)) + origPos[2])
						vehicle.setPosition(newPos)
						relocations += 1
			elif c == "test4":
				relocations = 0
				origPos = player.getVehicle().getPosition()
				vehicles = bf2.objectManager.getObjectsOfTemplate(pParts[0])
				for x in vehicles:
					if not x.isTitan():
						vehicle = x
						angle = 360*relocations
						newPos = ((relocations*math.cos(angle)) + origPos[0],origPos[1] + 1,(relocations*math.sin(angle)) + origPos[2])
						vehicle.setPosition(newPos)
						relocations += 1
			elif c == "test5":
				relocations = 0
				origPos = player.getVehicle().getPosition()
				vehicles = bf2.objectManager.getObjectsOfTemplate(pParts[0])
				for x in vehicles:
					if not x.isTitan():
						vehicle = x
						angle = 360*relocations
						newPos = ((relocations*math.cos(angle)) + origPos[0],origPos[1] + relocations,(relocations*math.sin(angle)) + origPos[2])
						vehicle.setPosition(newPos)
						relocations += 1
			elif c == "test6":
				relocations = 0
				origPos = player.getVehicle().getPosition()
				vehicles = bf2.objectManager.getObjectsOfTemplate(pParts[0])
				for x in vehicles:
					if not x.isTitan():
						vehicle = x
						angle = 360*relocations
						newPos = ((10*math.cos(angle)) + origPos[0],origPos[1] + 1,(10*math.sin(angle)) + origPos[2])
						vehicle.setPosition(newPos)
						relocations += 1
			elif c == "log":
				if glb.playerMessages[int(pParts[0])]:
					self.sM(glb.playerMessages[int(pParts[0])], True)
			elif c == "s":
				finalText = "3|C1001[|C1001" + self.name(self.getPlayerId(player), 1) + "|C1001]: "
				#for x in range(0, len(p)):
					#finalText = finalText + "|C1001" + p[x:x+1]
				p = p.split(" ")
				for x in range(0, len(p)):
					finalText = finalText + "|C1001" + p[x] + " "
				self.sM(finalText, True)
			elif c == "rank":
				if tParts > 1:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = [pParts[1]]
				bf2.gameLogic.sendRankEvent(player, int(pParts[0]), 0)
			elif c == "spawn":
				if tParts > 1:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = [pParts[1]]
				self.spawn(pParts[0], player)
			elif c == "deleteall":
				for x in self.spawnList:
					if x.getDamage() > 0:
						vehicle.setDamage(0)
						self.sM("success!", True)
					else: 
						self.spawnList.remove(int(pParts[0]))
			elif c == "relocate":
				if tParts > 3:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = pParts[1],pParts[2],pParts[3]
				vehicle = bf2.objectManager.getRootParent(player.getVehicle())
				newPos = (int(pParts[0]) + 0.0,int(pParts[1]) + 0.0,int(pParts[2]) + 0.0)
				if not vehicle.isTitan():
					vehicle.setPosition(newPos)
			elif c == "relocatehere":
				player2 = bf2.PlayerManager.Player(int(pParts[0]))
				vehicle = bf2.objectManager.getRootParent(player2.getVehicle())
				pos = player.getVehicle().getPosition()
				pos = pos[0] + 2,pos[1],pos[2] - 2
				if not vehicle.isTitan():
					vehicle.setPosition(pos)
			elif c == "relocateto":
				player2 = bf2.PlayerManager.Player(int(pParts[0]))
				vehicle = bf2.objectManager.getRootParent(player.getVehicle())
				pos = player2.getVehicle().getPosition()
				pos = pos[0] + 2,pos[1],pos[2] - 2
				if not vehicle.isTitan():
					vehicle.setPosition(pos)
			elif c == "move":
				if tParts > 3:
					player = bf2.PlayerManager.Player(int(pParts[0]))
					pParts = pParts[1],pParts[2],pParts[3]
				vehicle = bf2.objectManager.getRootParent(player.getVehicle())
				newPos = (int(pParts[0]) + vehicle.getPosition()[0],int(pParts[1]) + vehicle.getPosition()[1],int(pParts[2]) + vehicle.getPosition()[2])
				vehicle.setPosition(newPos)
			elif c == "active":
				self.rI("objecttemplate.active " + pParts[0])
			elif c == "projectile":
				self.rI("objecttemplate.active " + pParts[0])
				self.rI("objecttemplate.projectileTemplate " + pParts[1])
				self.rI("objecttemplate.fire.roundsperminute " + pParts[2])
			elif c == "pspeed":
				self.rI("objecttemplate.velocity " + pParts[0])
			elif c == "spawntime":
				if self.toggleSettings("sv.spawnTime", pParts[0]): self.sM("|C10013Spawn time set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Spawn time is already set to " + pParts[0] + ".", True)
			elif c == "revtime":
				if self.toggleSettings("sv.manDownTime", pParts[0]): self.sM("|C10013Revive time set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Revive time is already set to " + pParts[0] + ".", True)
			elif c == "ff":
				mines = "1"
				if p == "on":
					p = "100"
				elif p == "off":
					p = "0"
					mines = "0"
				self.toggleSettings("sv.soldierFriendlyFire", p)
				self.toggleSettings("sv.soldierSplashFriendlyFire", p)
				self.toggleSettings("sv.vehicleFriendlyFire", p)
				self.toggleSettings("sv.vehicleSplashFriendlyFire", p)
				self.toggleSettings("sv.friendlyFireWithMines", mines)
				self.sM("|C10013Global Friendly Fire set to: " + p + ".", True)
			elif c == "ffvehicles":
				if self.toggleSettings("sv.vehicleFriendlyFire", pParts[0]): self.sM("|C10013Vehicle Friendly Fire set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Vehicle Friendly Fire is already set to " + pParts[0] + ".", True)
			elif c == "ffsoldiers":
				if self.toggleSettings("sv.soldierFriendlyFire", pParts[0]): self.sM("|C10013Soldier Friendly Fire set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Soldier Friendly Fire is already set to " + pParts[0] + ".", True)
			elif c == "ffexplosives":
				if self.toggleSettings("sv.soldierSplashFriendlyFire", pParts[0]): self.sM("|C10013Soldier Splash Friendly Fire set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Soldier Splash Friendly Fire is already set to " + pParts[0] + ".", True)
			elif c == "ffvehicleexplosions":
				if self.toggleSettings("sv.vehicleSplashFriendlyFire", pParts[0]): self.sM("|C10013Vehicle Splash Friendly Fire set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Vehicle Splash Friendly Fire is already set to " + pParts[0] + ".", True)
			elif c == "ffmines":
				if p == "on":
					if self.toggleSettings("sv.friendlyFireWithMines", "1"): self.sM("|C10013Friendly Mines Fire on.", True)
					else: self.sM("|C10013Friendly Mines Fire is already on.", True)
				elif p == "off":
					if self.toggleSettings("sv.friendlyFireWithMines", "0"): self.sM("|C10013Friendly Mines Fire off.", True)
					else: self.sM("|C10013Friendly Mines Fire is already off.", True)
			elif c == "ab":
				if p == "on":
					if self.toggleSettings("sv.autoBalanceTeam", "1"): self.sM("|C10013Auto-balance on.", True)
					else: self.sM("|C10013Auto-balance is already on.", True)
				elif p == "off":
					if self.toggleSettings("sv.autoBalanceTeam", "0"): self.sM("|C10013Auto-balance off.", True)
					else: self.sM("|C10013Auto-balance is already off.", True)
			elif c == "ca":
				if p == "on":
					if self.toggleSettings("CombatAreaManager.use", "1"): self.sM("|C10013Combat Area on.", True)
				elif p == "off":
					if self.toggleSettings("CombatAreaManager.use", "0"): self.sM("|C10013Combat Area off.", True)
			elif c == "freecam":
				if p == "on":
					if self.toggleSettings("sv.allowFreeCam", "1"): self.sM("|C10013Free Camera on.", True)
					else: self.sM("|C10013Free Camera is already on.", True)
				elif p == "off":
					if self.toggleSettings("sv.allowFreeCam", "0"): self.sM("|C10013Free Camera off.", True)
					else: self.sM("|C10013Free Camera is already off.", True)
			elif c == "titanmovement":
				if p == "on":
					if self.toggleSettings("sv.allowTitanMovement", "1"): self.sM("|C10013Titan movement on.", True)
					else: self.sM("|C10013Titan movement is already on.", True)
				elif p == "off":
					if self.toggleSettings("sv.allowTitanMovement", "0"): self.sM("|C10013Titan movement off.", True)
					else: self.sM("|C10013Titan movement is already off.", True)
			elif c == "voting": # Make this include #vote commands
				if p == "on":
					if self.toggleSettings("sv.votingEnabled", "1"): self.sM("|C10013Voting turned on.", True)
					else: self.sM("|C10013Voting is already on.", True)
				elif p == "off":
					if self.toggleSettings("sv.votingEnabled", "0"): self.sM("|C10013Voting off.", True)
					else: self.sM("|C10013Voting is already off.", True)
			elif c == "votetime":
				if self.toggleSettings("sv.voteTime", pParts[0]): self.sM("|C10013Vote time set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Vote time is already set to " + pParts[0] + ".", True)
			elif c == "radiospamlimit":
				if self.toggleSettings("sv.radioSpamInterval", pParts[0]): self.sM("|C10013Radio spam interval set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Radio spam interval is already set to " + pParts[0] + ".", True)
			elif c == "radioblocktime":
				if self.toggleSettings("sv.radioBlockedDurationTime", pParts[0]): self.sM("|C10013Radio block time set to " + pParts[0] + ".", True)
				else: self.sM("|C10013Radio block time is already set to " + pParts[0] + ".", True)

	def masterAdminCommands(self, c, p, pParts, player):
		self.adminCommands(c, p, pParts, player)
		tParts = len(pParts)
		if c == "togglecommands":
			if not self.disabled:
				self.disabled = True
				self.sM("Commands disabled.", True)
			elif self.disabled:
				self.disabled = False
				self.sM("Commands enabled.", True)
		elif c == "pause":
			self.rI("gameLogic.togglePause")

	def rI(self, invoke):
		glb.rI(invoke)

	def sM(self, message, override): # add teams
		glb.serverMessage(message, override)

	def serverConfig(self, variableName): # bf2tech.org
		return host.rcon_invoke(variableName).strip()

	def toggleSettings(self, settings, mode):
		status = self.serverConfig(settings)
		if mode != status:
			self.rI(settings + " " + str(mode))
			return True
		else:
			return False

	def spawn(self, object, player): # Bugs
		vehiclesList = ['us_ag']
		self.rI("gameLogic.createObject " + object)
		obj = bf2.objectManager.getObjectsOfTemplate(object)
		obj = obj[len(obj) - 1]
		pos = bf2.objectManager.getRootParent(player.getVehicle()).getPosition()
		rot = bf2.objectManager.getRootParent(player.getVehicle()).getRotation()
		pPos = pos
		if obj.templateName in vehiclesList: pPos = pPos[0],pPos[1],pPos[2]
		else: pPos = pPos[0],pPos[1],pPos[2]
		bf2.objectManager.getRootParent(player.getVehicle()).setPosition(pPos)
		obj.setPosition(pos) # Relocating spawned object because of 2142 failure.
		obj.setRotation(rot) # Same thing.
		self.spawnList.append(obj)

	def name(self, id, type):
		if type == 0: return bf2.PlayerManager.Player(id).getName()
		elif type == 1: return bf2.PlayerManager.Player(id).getName().split(" ")[1]

	def admin(self, name):
		found = False
		for x in self.admins:
			if x.lower() == name.lower():
				found = True
		if found:
			return True
		else:
			return False

	def masterAdmin(self, name):
		found = False
		for x in self.masterAdmins:
			if x.lower() == name.lower():
				found = True
		if found:
			return True
		else:
			return False

	def textClip(self, text, list):
		for x in list:
			text = text.replace(x, "")
		return text

	def getPlayerId(self, player):
		for x in bf2.playerManager.getPlayers():
			if x.getName() == player.getName():
				return x.index

def start():
	return commandHandler()