import host
import bf2
import random
import math

class toolsHandler:
	def createPods(self): # creates pods to start with; as more pods are created from players the list will grow
		for x in range(0,20):
			host.rcon_invoke("gameLogic.createObject eu_pod_drop")

	def generatePodList(self):
		emptyPods = []
		playerVehicles = []
		for x in bf2.playerManager.getPlayers():
			playerVehicles.append(bf2.objectManager.getRootParent(x.getVehicle()))
		for x in bf2.objectManager.getObjectsOfTemplate("eu_pod_drop"):
			if not x in playerVehicles: # don't add a player's pod to list
				emptyPods.append(x)
		return emptyPods

	def podDecoys(self, team):
		if bf2.playerManager.getNumberOfAlivePlayersInTeam(team) <= 0: return
		victims = []
		for x in bf2.playerManager.getPlayers():
			if x.getTeam() == team and x.isAlive():
				victims.append(x)
		self.createPods() # add pods to the map
		pods = self.generatePodList() # get the list of available pods to relocate (recycling)
		podAmount = int(math.floor(len(pods)/len(victims))) # amount of pods distributed per person
		if podAmount < 1: podAmount = 1
		for x in victims:
			for i in range(0,podAmount):
				obj = pods[0]
				obj.setPosition(self.randomPodPosition(x))
				pods.remove(obj)
		for x in pods: # leftover pods, redistribute them to random victims
			x.setPosition(self.randomPodPosition(victims[random.randint(0,len(victims))]))

	def randomPodPosition(self, player):
		pos = bf2.objectManager.getRootParent(player.getVehicle()).getPosition()
		randPos = ((pos[0] + random.randint(-20,20),pos[1] + random.randint(80,250),pos[2] + random.randint(-20,20)))
		return randPos

	'''def podSpawn(self, object, player):
		obj = "Error"
		if pods:
			obj = pods[podCount]
			podCount += 1
		else:
			oldObjs = host.omgr_getObjectsOfTemplate(object)
			host.rcon_invoke("gameLogic.createObject " + object)
			newObjs = host.omgr_getObjectsOfTemplate(object)
			for x in newObjs:
				if x not in oldObjs:
					obj = x
		pos = bf2.objectManager.getRootParent(player.getVehicle()).getPosition()
		randPos = ((pos[0] + random.randint(-20,20),pos[1] + random.randint(80,250),pos[2] + random.randint(-20,20)))
		obj.setPosition(randPos)

	def podSpawn(self, object, player):
		host.rcon_invoke("game.sayAll 1")
		obj = "Error"
		host.rcon_invoke("game.sayAll 2")
		if podsActive:
			host.rcon_invoke("game.sayAll 3")
			obj = pods[podCount]
			host.rcon_invoke("game.sayAll 4")
			podCount += 1
			host.rcon_invoke("game.sayAll 5")
		else:
			host.rcon_invoke("game.sayAll 6")
			oldObjs = host.omgr_getObjectsOfTemplate(object)
			host.rcon_invoke("game.sayAll 7")
			host.rcon_invoke("gameLogic.createObject " + object)
			host.rcon_invoke("game.sayAll 8")
			newObjs = host.omgr_getObjectsOfTemplate(object)
			host.rcon_invoke("game.sayAll 9")
			for x in newObjs:
				host.rcon_invoke("game.sayAll 10")
				if x not in oldObjs:
					host.rcon_invoke("game.sayAll 11")
					obj = x
					host.rcon_invoke("game.sayAll 12")
		pos = bf2.objectManager.getRootParent(player.getVehicle()).getPosition()
		host.rcon_invoke("game.sayAll 13")
		randPos = ((pos[0] + random.randint(-20,20),pos[1] + random.randint(80,250),pos[2] + random.randint(-20,20)))
		host.rcon_invoke("game.sayAll 14")
		obj.setPosition(randPos)

	def podDecoys(self, team):
		self.generatePodList()
		for x in bf2.playerManager.getPlayers():
			#if x.getTeam() == team:
				#host.rcon_invoke("game.sayAll 3")
			for i in range(1,random.randint(2,5)):
				self.podSpawn("eu_pod_drop", x)
		pods = []
		podsActive = False
		podCount = 0'''

def start():
	return toolsHandler()